// by Tony Chang
// Do what you want with this, just know that I'm not responsible 
// for anything bad that might happen.

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <fstream.h>
#include "textedit.h"
#include "lsapi.h"

#include <list>
#include <string>
using namespace std;

HWND parent;
BOOL DEBUG;

// getToken grabs a token and clobbers info that is parsed
void getToken(char line[4096], char temp[4096])
{
	int offset = 0, i;
	bool endquote = false;

	while (line[offset] == ' ')
	{
		offset++;
	}

	if (line[offset] == '"')
	{
		offset++;
		endquote = true;
	}

	for (i = 0; i+offset < int(strlen(line)); i++)
	{
		// \ is the escape code
		if (line[i+offset] == '\\' && int(strlen(line)) != i+offset+1)
		{
			if (line[i+offset+1] == '"' || line[i+offset+1] == '\\')
			{
				offset++;
				temp[i] = line[i+offset];
				continue;
			}
			else if (line[i+offset+1] == '^')
			{
				offset++;
				temp[i] = '!';
				continue;
			}
			else if (line[i+offset+1] == '#')
			{
				offset++;
				temp[i] = '$';
				continue;
			}
			else if (DEBUG==TRUE)
			{
				if (line[i+offset+1] < '0' || line[i+offset+1] > '9')
					MessageBox(NULL, "Unknown escape code", "Error", MB_OK);
			}
		}

		if (line[i+offset] == '"' && endquote)
			break;
		else if (line[i+offset] == ' ' && !endquote)
			break;
		else
			temp[i] = line[i+offset];
	}
	temp[i] = '\0';

	if (i+offset+1 > int(strlen(line)))
	{
		line[0] = '\0';
	}
	else
	{
		strcpy(line, line+i+offset+1);
	}
}

void textAppend(HWND caller, const char* arg)
{
	char filename[4096], str[4096];
	char rest[4096];
	strcpy(rest, arg);

	getToken(rest, filename);
	getToken(rest, str);

	if (DEBUG==TRUE)
	{
		MessageBox(NULL, filename, "Filename", MB_OK);
		MessageBox(NULL, str, "String", MB_OK);
		MessageBox(NULL, rest, "Extra Chars", MB_OK);
	}

	::ofstream file;
	file.open(filename, ios::nocreate | ios::app);

	if (!file.fail())
	{
		file << str << endl;
	}
	else if (DEBUG==TRUE)
	{
		MessageBox(NULL, "Failed to open file", "Error", MB_OK);
	}
	file.close();
}

void textDelete(HWND caller, const char* arg)
{
	char filename[4096], regex[4096], input[4096];
	char rest[4096];
	regexp *r;
	strcpy(rest, arg);

	getToken(rest, filename);
	getToken(rest, regex);

	if (DEBUG==TRUE)
	{
		MessageBox(NULL, filename, "Filename", MB_OK);
		MessageBox(NULL, regex, "Regular Expression", MB_OK);
		MessageBox(NULL, rest, "Extra Chars", MB_OK);
	}

	r = regcomp(regex);

	::ifstream file;
	file.open(filename, ios::nocreate);

	if (!file.fail())
	{
		list<string> l;
		string s;
		while (file.getline(input, 4096))
		{
			if (!regexec(r, input))
			{
				s = input;
				l.push_back(s);
			}
			else if (DEBUG==TRUE)
			{
				MessageBox(NULL, input, "MATCH", MB_OK);
			}
		}
		file.close();
		::ofstream outfile;
		outfile.open(filename);
		for (list<string>::const_iterator lci = l.begin(); lci!=l.end(); lci++)
		{
			outfile << lci->data() << endl;
		}
		l.clear();
	}
	else if (DEBUG==TRUE)
	{
		file.close();
		MessageBox(NULL, "Failed to open file", "Error", MB_OK);
	}
}

void textReplace(HWND caller, const char* arg)
{
	char filename[4096], regex[4096], input[4096], replace[4096];
	char rest[4096], buf[4096];
	regexp *r;
	strcpy(rest, arg);

	getToken(rest, filename);
	getToken(rest, regex);
	getToken(rest, replace);

	if (DEBUG==TRUE)
	{
		MessageBox(NULL, filename, "Filename", MB_OK);
		MessageBox(NULL, regex, "Regular Expression", MB_OK);
		MessageBox(NULL, replace, "Replace string", MB_OK);
		MessageBox(NULL, rest, "Extra Chars", MB_OK);
	}

	r = regcomp(regex);

	::ifstream file;
	file.open(filename, ios::nocreate);

	if (!file.fail())
	{
		list<string> l;
		string s;
		while (file.getline(input, 4096))
		{
			if (regexec(r, input))
			{
				regsub(r, replace, buf);
				s = buf;
				l.push_back(buf);
				if (DEBUG==TRUE)
				{
					MessageBox(NULL, input, "MATCH", MB_OK);
					MessageBox(NULL, buf, "Replaced string", MB_OK);
				}
			}
			else
			{
				s = input;
				l.push_back(input);
			}
		}
		file.close();
		::ofstream outfile;
		outfile.open(filename);
		for (list<string>::const_iterator lci = l.begin(); lci!=l.end(); lci++)
		{
			outfile << lci->data() << endl;
		}
		l.clear();
	}
	else if (DEBUG==TRUE)
	{
		file.close();
		MessageBox(NULL, "Failed to open file", "Error", MB_OK);
	}
}

int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	parent = ParentWnd;

	AddBangCommand("!textappend", textAppend);
	AddBangCommand("!textdel", textDelete);
	AddBangCommand("!textreplace", textReplace);
	DEBUG = GetRCBool("TextDebug", TRUE);
//	GetRCString("WallpaperList", szWPList, "c:\\litestep\\wplist.txt", 256);
	return 0;
}

void quitModule(HINSTANCE dllInst)
{
	RemoveBangCommand("!textappend");
	RemoveBangCommand("!textdel");
	RemoveBangCommand("!textreplace");
}
